<template>
	<view class="content">
		<view class="navbar" :style="{ position: headerPosition, top: headerTop }">
			<!-- 兼容小程序搜索 -->
			<!-- #ifdef MP -->
			<view class="input-box flex">
				<view class=" input-content flex">
					<view class="iconfont iconsearch"></view>
					<view class="input"><input type="text" v-model="keyword" placeholder="请输入搜索内容" /></view>
				</view>
				<view class="input-button flex" @click="navTo"><text>搜索</text></view>
			</view>
			<!-- #endif -->
			<view class="flex navbar-box">
				<view class="nav-item" :class="{ current: filterIndex === 0 }" @click="tabClick(0)">综合排序</view>
				<view class="nav-item" :class="{ current: filterIndex === 1 }" @click="tabClick(1)">
					<text>销量优先</text>
					<view class="p-box">
						<text :class="{ active: numberOrder === 1 && filterIndex === 1 }" class="iconfont iconfold"></text>
						<text :class="{ active: numberOrder === 2 && filterIndex === 1 }" class="iconfont iconfold xia"></text>
					</view>
				</view>
				<view class="nav-item" :class="{ current: filterIndex === 2 }" @click="tabClick(2)">
					<text>价格</text>
					<view class="p-box">
						<text :class="{ active: priceOrder === 1 && filterIndex === 2 }" class="iconfont iconfold"></text>
						<text :class="{ active: priceOrder === 2 && filterIndex === 2 }" class="iconfont iconfold xia"></text>
					</view>
				</view>
				<text class="cate-item iconfont iconapps" @click="toggleCateMask('show')"></text>
			</view>
		</view>
		<view class="goods-list">
			<view v-for="(item, index) in goodsList" :key="index" class="goods-item" @click="navToDetailPage(item)">
				<view class="image-wrapper"><image :src="item.image" mode="aspectFill"></image></view>
				<text class="title">{{ item.store_name }}</text>
				<view class="price-box">
					<text class="price">{{ item.price }}</text>
					<text>已售 {{ item.sales+(item.ficti||0) }}</text>
				</view>
			</view>
		</view>
		<uni-load-more :status="loadingType"></uni-load-more>

		<view class="cate-mask" :class="cateMaskState === 0 ? 'none' : cateMaskState === 1 ? 'show' : ''" @click="toggleCateMask">
			<view class="cate-content" @click.stop.prevent="stopPrevent" @touchmove.stop.prevent="stopPrevent">
				<scroll-view scroll-y class="cate-list">
					<view><view class="cate-item b-b" @click="changeCate(tItem)">全部</view></view>
					<view v-for="item in cateList" :key="item.id">
						<view class="cate-item b-b two">{{ item.cate_name }}</view>
						<view v-for="tItem in item.children" :key="tItem.id" class="cate-item b-b" :class="{ active: tItem.id == cateId }" @click="changeCate(tItem)">
							{{ tItem.cate_name }}
						</view>
					</view>
				</scroll-view>
			</view>
		</view>
	</view>
</template>

<script>
import uniLoadMore from '@/components/uni-load-more/uni-load-more.vue';
import { getProducts,productDetail } from '@/api/product.js';
import { getList } from '@/api/category.js';
import { mapState } from 'vuex';
export default {
	computed: {
		...mapState(['shopId'])
	},
	components: {
		uniLoadMore
	},
	data() {
		return {
			cateMaskState: 0, //分类面板展开状态
			headerPosition: 'fixed',
			headerTop: '0px',
			loadingType: 'more', //加载更多状态
			filterIndex: 0, //查询类型
			numberOrder: 0, //1 销量从低到高 2销量从高到低
			limit: 5, //每次加载数据条数
			page: 1, //当前页数
			cateId: 0, //已选三级分类id
			priceOrder: 0, //1 价格从低到高 2价格从高到低
			cateList: [], //分类列表
			goodsList: [], //商品列表
			keyword: '' ,//关键字
			specList:'',
			specSelected:'',
			productValue:[]
		};
	},
	// #ifndef MP
	//点击导航栏 buttons 时触发
	onNavigationBarButtonTap(e) {
		const index = e.index;
		if (index === 0) {
			this.navTo();
		}
	},
	// 点击键盘搜索事件
	onNavigationBarSearchInputConfirmed(e) {
		this.navTo();
	},
	// 搜索栏内容变化事件
	onNavigationBarSearchInputChanged(e) {
		this.keyword = e.text;
	},
	// #endif
	onLoad(options) {
		// #ifdef H5
		//this.headerTop = document.getElementsByTagName('uni-page-head')[0].offsetHeight + 'px';
		// #endif
		this.cateId = options.tid || '';
		this.loadCateList();
		this.loadData();
	},
	onPageScroll(e) {
		//兼容iOS端下拉时顶部漂移
		if (e.scrollTop >= 0) {
			this.headerPosition = 'fixed';
		} else {
			this.headerPosition = 'absolute';
		}
	},
	//下拉刷新
	onPullDownRefresh() {
		this.loadData('refresh');
	},
	//加载更多
	onReachBottom() {
		this.loadData();
	},
	methods: {
		// 点击触发搜索事件
		navTo() {
			this.tabCurrentIndex = 1;
			this.infoData();
		},
		// 查询切换后初始化
		infoData() {
			// 初始化页数
			this.page = 1;
			// 初始化数组
			uni.pageScrollTo({
				duration: 300,
				scrollTop: 0
			});
			// 加载数据
			this.loadData('refresh', 1);
			uni.showLoading({
				title: '正在加载'
			});
		},
		//加载分类
		async loadCateList(fid, sid) {
			let obj = this;
			getList({}).then(function(e) {
				obj.cateList = e.data;
			});
		},
		//加载商品 ，带下拉刷新和上滑加载
		async loadData(type = 'add', loading) {
			let obj = this;
			let data = {
				page: obj.page,
				limit: obj.limit,
				sid: obj.cateId, //分类id
				mer_id: obj.shopId || '',
				keyword: obj.keyword || '',
				isPink: 1
			};
			//没有更多直接返回
			if (type === 'add') {
				if (obj.loadingType === 'nomore') {
					return;
				}
				obj.loadingType = 'loading';
			} else {
				obj.loadingType = 'more';
			}

			if (this.filterIndex == 1) {
				data.salesOrder = obj.numberOrder == 1 ? 'asc' : 'desc';
			}
			if (this.filterIndex == 2) {
				data.priceOrder = obj.priceOrder == 1 ? 'asc' : 'desc';
			}
			getProducts(data).then(function(e) {
				if (type === 'refresh') {
					console.log('jinru');
					// 清空数组
					obj.goodsList = [];
				}
				let goodsList = obj.goodsList.concat(e.data);
				let a = e.data.length;
				for(let i = 0 ;i<a;i++){
					let goodsid;
					goodsid = e.data[i].id;
					productDetail({}, goodsid)
						.then(({data}) => {
							obj.specList = data.productAttr;//保存产品属性
							obj.specSelected = []; //初始化默认选择对象
							obj.productValue = data.productValue;
							for (let i = 0; i < obj.specList.length; i++) {
								// 设置默认数据
								let attrValue = obj.specList[i].attr_value[0];
								attrValue.check = true;
								obj.specSelected.push(attrValue.attr);
							}
							let str = obj.specSelected.join(',');
							let actionPrice = obj.productValue[str].price;
							if(obj.page == 1)
							{
								goodsList[i].price = actionPrice;
							}else{
								let a = (obj.page - 1) * 5 + i;
								goodsList[a].price = actionPrice;
							}
						});
				}
				setTimeout(function(){ 
					obj.goodsList = goodsList;
					//判断是否还有下一页，有是more  没有是nomore
					if (obj.limit == e.data.length) {
						obj.page++;
						obj.loadingType = 'more';
					} else {
						obj.loadingType = 'nomore';
					}
					if (type === 'refresh') {
						if (loading == 1) {
							uni.hideLoading();
						} else {
							uni.stopPullDownRefresh();
						}
					}
				}, 1000);

			});
		},
		//筛选点击
		tabClick(index) {
			// 防止重复点击综合排序
			if (this.filterIndex === 0 && this.filterIndex === index) {
				return;
			}
			this.filterIndex = index;
			// 判断是否为销量优先
			if (index === 1) {
				this.numberOrder = this.numberOrder === 1 ? 2 : 1;
			}
			// 判断是否为价格优先
			if (index === 2) {
				this.priceOrder = this.priceOrder === 1 ? 2 : 1;
			}
			// 初始化页数
			this.page = 1;
			// 初始化数组
			uni.pageScrollTo({
				duration: 300,
				scrollTop: 0
			});
			this.loadData('refresh', 1);
			uni.showLoading({
				title: '正在加载'
			});
		},
		//显示分类面板
		toggleCateMask(type) {
			let timer = type === 'show' ? 10 : 300;
			let state = type === 'show' ? 1 : 0;
			this.cateMaskState = 2;
			setTimeout(() => {
				this.cateMaskState = state;
			}, timer);
		},
		//分类点击
		changeCate(item) {
			if (item) {
				this.cateId = item.id;
			} else {
				this.cateId = '';
			}
			this.toggleCateMask();
			this.infoData();
		},
		//详情
		// navToDetailPage(item) {
		// 	let id = item.id;
		// 	uni.navigateTo({
		// 		url: `/pages/product/product?type=2&id=${id}`
		// 	});
		// },
		//商品详情
		navToDetailPage(item) {
			let id = item.id;
			uni.navigateTo({
				url: '/pages/product/product?id=' + id
			});
		},
		stopPrevent() {}
	}
};
</script>

<style lang="scss">
page,
.content {
	background: $page-color-base;
}
.content {
	padding-top: 40px;
	/* #ifdef MP */
	padding-top: 84px;
	/* #endif */
}
/* #ifdef MP || APP-PLUS*/
.input-box {
	padding: 25rpx;
	/* #ifdef APP-PLUS */
	margin-top: var(--status-bar-height);
	/* #endif */
	background-color: #ffffff;
	height: 44px;
	.iconsearch {
		font-size: 50rpx;
	}
	.input-content {
		border-radius: 99rpx;
		flex-grow: 1;
		padding: 5rpx 30rpx;
		background-color: rgba(231, 231, 231, 0.7);
		.input {
			flex-grow: 1;
			input {
				font-size: $font-base;
			}
		}
	}
	.input-button {
		padding-left: 20rpx;
		font-size: $font-base;
		height: 100%;
	}
}
/* #endif */

.navbar {
	position: fixed;
	left: 0;
	top: var(--window-top);
	width: 100%;
	//height: 40px;
	background: #fff;
	box-shadow: 0 2rpx 10rpx rgba(0, 0, 0, 0.06);
	z-index: 10;
	.navbar-box {
		height: 40px;
		.nav-item {
			flex: 1;
			display: flex;
			justify-content: center;
			align-items: center;
			height: 100%;
			font-size: 30rpx;
			color: $font-color-dark;
			position: relative;
			&.current {
				color: $base-color;
				// &:after {
				// 	content: '';
				// 	position: absolute;
				// 	left: 50%;
				// 	bottom: 0;
				// 	transform: translateX(-50%);
				// 	width: 120rpx;
				// 	height: 0;
				// 	border-bottom: 4rpx solid $base-color;
				// }
			}
		}
		.p-box {
			display: flex;
			flex-direction: column;
			.iconfont {
				display: flex;
				align-items: center;
				justify-content: center;
				width: 30rpx;
				height: 14rpx;
				line-height: 1;
				margin-left: 4rpx;
				font-size: 26rpx;
				color: #888;
				&.active {
					color: $base-color;
				}
			}
			.xia {
				transform: scaleY(-1);
			}
		}
		.cate-item {
			display: flex;
			justify-content: center;
			align-items: center;
			height: 100%;
			width: 80rpx;
			position: relative;
			font-size: 44rpx;
			&:after {
				content: '';
				position: absolute;
				left: 0;
				top: 50%;
				transform: translateY(-50%);
				border-left: 1px solid #ddd;
				width: 0;
				height: 36rpx;
			}
		}
	}
}

/* 分类 */
.cate-mask {
	position: fixed;
	left: 0;
	top: var(--window-top);
	bottom: 0;
	width: 100%;
	background: rgba(0, 0, 0, 0);
	z-index: 95;
	transition: 0.3s;

	.cate-content {
		width: 630rpx;
		height: 100%;
		background: #fff;
		float: right;
		transform: translateX(100%);
		transition: 0.3s;
	}
	&.none {
		display: none;
	}
	&.show {
		background: rgba(0, 0, 0, 0.4);

		.cate-content {
			transform: translateX(0);
		}
	}
}
.cate-list {
	display: flex;
	flex-direction: column;
	height: 100%;
	.cate-item {
		display: flex;
		align-items: center;
		height: 90rpx;
		padding-left: 30rpx;
		font-size: 28rpx;
		color: #555;
		position: relative;
	}
	.two {
		height: 64rpx;
		color: #303133;
		font-size: 30rpx;
		background: #f8f8f8;
	}
	.active {
		color: $base-color;
	}
}

/* 商品列表 */
.goods-list {
	display: flex;
	flex-wrap: wrap;
	padding: 0 30rpx;
	// background: #fff;
	// padding-top: 30rpx;
	.goods-item {
		display: flex;
		flex-direction: column;
		width: 48%;
		padding-bottom: 30rpx;
		border-radius: 10rpx;
		background: #FFFFFF;
		margin-top: 20rpx;
		&:nth-child(2n + 1) {
			margin-right: 4%;
		}
	}
	.image-wrapper {
		width: 100%;
		height: 330rpx;
		border-radius: 10rpx 10rpx 0 0;
		overflow: hidden;
		image {
			width: 100%;
			height: 100%;
			opacity: 1;
		}
	}
	.title {
		font-size: $font-base;
		color: $font-color-dark;
		line-height: 1.5;
		// height: 85rpx;
		padding-top: 20rpx;
		padding: 20rpx;
		overflow: hidden;
		text-overflow: ellipsis;
		white-space: nowrap;
	}
	.price-box {
		display: flex;
		align-items: center;
		justify-content: space-between;
		padding: 0 20rpx;
		font-size: 24rpx;
		color: $font-color-light;
	}
	.price {
		font-size: $font-lg;
		color: $uni-color-primary;
		line-height: 1;
		&:before {
			content: '￥';
			font-size: 26rpx;
		}
	}
}
</style>
